commit 89c98d127a32d48a7d27970d3ec76eb38f69e13d
Author: Václav Jirák <jirakv95@gmail.com>
Date:   Sun May 26 22:02:06 2019 +0200

    Re #7498 Global settings component implemented

diff --git a/webapp/src/app/dashboard/employer-dashboard/employer-dashboard.component.ts b/webapp/src/app/dashboard/employer-dashboard/employer-dashboard.component.ts
index 3da38cc..c669dbd 100644
--- a/webapp/src/app/dashboard/employer-dashboard/employer-dashboard.component.ts
+++ b/webapp/src/app/dashboard/employer-dashboard/employer-dashboard.component.ts
@@ -35,27 +35,6 @@ export class EmployerDashboardComponent implements OnInit {
     //
     // this.usersService.getVacationRequests()
     //   .subscribe((data: Requests) => this.daysOffRequests = data);
-
-    // Tmp mock
-    // this.profile = {
-    //   id: 1,
-    //   name: {
-    //     first: 'Jon',
-    //     last: 'Doe',
-    //   },
-    //   photo: 'http://mosaddek.com/theme/diverse/assets/img/user1.png',
-    //   settings: {
-    //     notification: new Date(2019, 3, 25, 18, 0)
-    //   },
-    //   vacation: {
-    //     value: 5,
-    //     unit: TimeUnit.DAY,
-    //   },
-    //   sickDay: {
-    //     value: 10,
-    //     unit: TimeUnit.DAY
-    //   }
-    // };
   }
 
   private userApproved(requestId: number, approved: boolean) {
@@ -78,6 +57,5 @@ export class EmployerDashboardComponent implements OnInit {
 
   onMonthSelect(month: number) {
     // TODO API CALL
-    console.log(month);
   }
 }
diff --git a/webapp/src/app/day-picker/day-picker.component.ts b/webapp/src/app/day-picker/day-picker.component.ts
index d49bdf9..b1c6d57 100644
--- a/webapp/src/app/day-picker/day-picker.component.ts
+++ b/webapp/src/app/day-picker/day-picker.component.ts
@@ -34,14 +34,13 @@ export class DayPickerComponent {
 
   constructor(private localizationService: LocalizationService) {
     this.locale = localizationService.defaultLanguage;
-    localizationService.currentLanguage
+    localizationService.currentLanguageSubject
       .subscribe((data) => {
         this.locale = data;
       });
 
     this.viewDate = new Date();
     this.currentMonth = this.viewDate.getMonth();
-    console.log(this.currentMonth);
   }
 
   /**
diff --git a/webapp/src/app/employees/default-settings-dialog/default-settings-dialog.component.ts b/webapp/src/app/employees/default-settings-dialog/default-settings-dialog.component.ts
new file mode 100644
index 0000000..9fd66d1
--- /dev/null
+++ b/webapp/src/app/employees/default-settings-dialog/default-settings-dialog.component.ts
@@ -0,0 +1,50 @@
+import {Component, Inject} from '@angular/core';
+import {MAT_DIALOG_DATA, MatDialogRef} from '@angular/material';
+
+@Component({
+  selector: 'app-default-settings',
+  templateUrl: './default-settings-dialog.component.html',
+  styleUrls: ['./default-settings.component.sass']
+})
+export class DefaultSettingsDialogComponent {
+  MINUTE_STEP = 15;
+
+  constructor(
+    public dialogRef: MatDialogRef<DefaultSettingsDialogComponent>,
+    @Inject(MAT_DIALOG_DATA) public data: DefaultSettingsDialogData
+  ) {
+  }
+
+  onConfirmClick(): void {
+    this.dialogRef.close({
+      isConfirmed: true,
+      notificationDatetime: this.toNotificationDatetime(),
+      sickdayCount: this.data.sickdaysCount
+    });
+  }
+
+  onCloseClick(): void {
+    this.dialogRef.close({
+      isConfirmed: false
+    });
+  }
+
+  private toNotificationDatetime(): Date {
+    const splittedTime = this.data.notificationTime.split(':');
+
+    return new Date(
+      this.data.notificationDate.getFullYear(),
+      this.data.notificationDate.getMonth(),
+      this.data.notificationDate.getDate(),
+      Number(splittedTime[0]),
+      Number(splittedTime[1])
+    );
+  }
+
+}
+
+export class DefaultSettingsDialogData {
+  notificationDate: Date;
+  notificationTime: string;
+  sickdaysCount: number;
+}
diff --git a/webapp/src/app/employees/default-settings-dialog/default-settings.component.sass b/webapp/src/app/employees/default-settings-dialog/default-settings.component.sass
new file mode 100644
index 0000000..c313b54
--- /dev/null
+++ b/webapp/src/app/employees/default-settings-dialog/default-settings.component.sass
@@ -0,0 +1,2 @@
+.dialog-label
+  font-weight: bold
diff --git a/webapp/src/app/employees/employees-list.component.sass b/webapp/src/app/employees/employees-list.component.sass
index 01c6ece..1db9811 100644
--- a/webapp/src/app/employees/employees-list.component.sass
+++ b/webapp/src/app/employees/employees-list.component.sass
@@ -10,6 +10,11 @@
   @extend .basic-component
   margin-top: 15px
 
+  #settings-button
+    outline: none
+    i
+      color: grey
+      margin-bottom: 3px
 
 .sickday
   background: #ffc0c0
diff --git a/webapp/src/app/employees/employees-list.component.ts b/webapp/src/app/employees/employees-list.component.ts
index 3df4ded..b3d1fa6 100644
--- a/webapp/src/app/employees/employees-list.component.ts
+++ b/webapp/src/app/employees/employees-list.component.ts
@@ -1,12 +1,16 @@
 import {Component, OnInit} from '@angular/core';
 import {UsersService} from '../services/users.service';
-import {VacationType} from '../enums/common.enum';
+import {Languages, VacationType} from '../enums/common.enum';
 import {MatDialog, MatSnackBar} from '@angular/material';
 import {EditEmployeeDialogComponent} from './edit-employee-dialog/edit-employee-dialog.component';
 import {DayInfo, User} from './user.model';
 import {UserBasicInformation, UserProfile} from '../models/user.model';
-import {UserService} from '../services/user.service';
+import {DefaultSettingsDialogComponent} from './default-settings-dialog/default-settings-dialog.component';
+import {Settings} from '../models/settings.model';
 import {SettingsService} from '../services/settings.service';
+import {UserService} from '../services/user.service';
+import {LocalizationService} from '../localization/localization.service';
+import {DateFormatterService} from '../shared/date-formatter.service';
 
 const daysOfWeek: string[] = [
   'po',
@@ -30,11 +34,14 @@ export class EmployeesListComponent implements OnInit {
   private _employeesBasicInformation: UserBasicInformation[] = [];
   readonly _todayDate: Date = new Date();
 
-  constructor(private usersService: UsersService,
-              private userService: UserService,
-              private settingsService: SettingsService,
-              public dialog: MatDialog,
-              private snackBar: MatSnackBar) {
+  constructor(
+    private usersService: UsersService,
+    private userService: UserService,
+    private settingsService: SettingsService,
+    private localizationService: LocalizationService,
+    private dateFormatterService: DateFormatterService,
+    public dialog: MatDialog,
+    private snackBar: MatSnackBar) {
     this.generateDays();
     this.generateDates();
     this.editDates();
@@ -54,6 +61,37 @@ export class EmployeesListComponent implements OnInit {
       });
   }
 
+  openDefaultSettingsDialog(): void {
+    this.settingsService.getDefaultSettingsWithLanguage(Languages.CZECH)
+      .subscribe((settingsData: Settings) => {
+        const parsedDate = new Date(settingsData.notification);
+
+        const parsedSettings = {
+          notificationDate: new Date(parsedDate.getFullYear(), parsedDate.getMonth(), parsedDate.getDate()),
+          notificationTime: parsedDate.getHours() + ':' + parsedDate.getMinutes(),
+          sickdaysCount: settingsData.sickdayCount
+        };
+
+        this.dialog.open(DefaultSettingsDialogComponent, {
+            data: parsedSettings,
+            width: '300px'
+          })
+          .afterClosed().subscribe(data => {
+            if (data && data.isConfirmed) {
+              // TODO API CALL
+              // this.settingsService.postDefaultSettingsWithLanguage(this.toSettings(data), this.localizationService.getCurrentLanguage());
+            }
+          });
+      });
+  }
+
+  private toSettings(data): Settings {
+    return {
+      sickdayCount: data.sickdayCount,
+      notification: this.dateFormatterService.formatDate(data.notificationDatetime)
+    };
+  }
+
   private generateDays(): void {
     this.days = [];
 
diff --git a/webapp/src/app/employees/employees.module.ts b/webapp/src/app/employees/employees.module.ts
index 54a83c2..10bd8ff 100644
--- a/webapp/src/app/employees/employees.module.ts
+++ b/webapp/src/app/employees/employees.module.ts
@@ -1,14 +1,27 @@
 import {NgModule} from '@angular/core';
 import {CommonModule} from '@angular/common';
 import {EmployeesListComponent} from './employees-list.component';
-import {MatDatepickerModule, MatDialogModule, MatFormFieldModule, MatInputModule, MatRadioModule, MatTableModule} from '@angular/material';
+
+import {
+  MatButtonModule,
+  MatDatepickerModule,
+  MatDialogModule,
+  MatFormFieldModule,
+  MatInputModule,
+  MatRadioModule,
+  MatTableModule
+} from '@angular/material';
 import {EditEmployeeDialogComponent} from './edit-employee-dialog/edit-employee-dialog.component';
 import {FormsModule} from '@angular/forms';
+import {DefaultSettingsDialogComponent} from './default-settings-dialog/default-settings-dialog.component';
+import {NgbTimepickerModule} from '@ng-bootstrap/ng-bootstrap';
+import {SharedModule} from '../shared/shared.module';
 
 @NgModule({
   declarations: [
     EmployeesListComponent,
     EditEmployeeDialogComponent,
+    DefaultSettingsDialogComponent
   ],
   imports: [
     CommonModule,
@@ -18,10 +31,14 @@ import {FormsModule} from '@angular/forms';
     MatInputModule,
     MatDialogModule,
     MatRadioModule,
-    MatDatepickerModule
+    MatDatepickerModule,
+    NgbTimepickerModule,
+    MatButtonModule,
+    SharedModule
   ],
   entryComponents: [
     EditEmployeeDialogComponent,
+    DefaultSettingsDialogComponent
   ]
 })
 export class EmployeesModule { }
diff --git a/webapp/src/app/localization/localization.service.ts b/webapp/src/app/localization/localization.service.ts
index 932ccf5..8ea0f1a 100644
--- a/webapp/src/app/localization/localization.service.ts
+++ b/webapp/src/app/localization/localization.service.ts
@@ -1,9 +1,10 @@
-import { Injectable } from '@angular/core';
-import { TranslateService } from '@ngx-translate/core';
-import { registerLocaleData } from '@angular/common';
+import {Injectable} from '@angular/core';
+import {TranslateService} from '@ngx-translate/core';
+import {registerLocaleData} from '@angular/common';
 import localeEn from '@angular/common/locales/en';
 import localeCs from '@angular/common/locales/cs';
-import { Subject } from 'rxjs';
+import {Subject} from 'rxjs';
+import {Languages} from "../enums/common.enum";
 
 @Injectable({
   providedIn: 'root'
@@ -11,10 +12,12 @@ import { Subject } from 'rxjs';
 export class LocalizationService {
   readonly defaultLanguage = 'en';
 
-  currentLanguage: Subject<string>;
+  currentLanguageSubject: Subject<string>;
+
+  private currentLanguage = this.defaultLanguage;
 
   constructor(private translate: TranslateService) {
-    this.currentLanguage = new Subject<string>();
+    this.currentLanguageSubject = new Subject<string>();
 
     registerLocaleData(localeEn);
     registerLocaleData(localeCs);
@@ -24,6 +27,17 @@ export class LocalizationService {
 
   switchLanguage(lang: string) {
     this.translate.use(lang);
-    this.currentLanguage.next(lang);
+    this.currentLanguageSubject.next(lang);
+    this.currentLanguage = lang;
+  }
+
+  getCurrentLanguage(): Languages {
+    switch (this.currentLanguage) {
+      case 'cs':
+        return Languages.CZECH;
+      case 'en':
+      default:
+        return Languages.ENGLISH;
+    }
   }
 }
diff --git a/webapp/src/app/shared/date-formatter.service.ts b/webapp/src/app/shared/date-formatter.service.ts
new file mode 100644
index 0000000..d8b47ab
--- /dev/null
+++ b/webapp/src/app/shared/date-formatter.service.ts
@@ -0,0 +1,38 @@
+import {Injectable} from '@angular/core';
+
+@Injectable({
+  providedIn: 'root'
+})
+export class DateFormatterService {
+  constructor() { }
+
+  /**
+   * Formats date to a following format: yyyy/mm/dd hh:mm:ss
+   * @param date Date which is formatted
+   */
+  formatDate(date: Date): string {
+    let result = '';
+
+    result += this.formatToDoubleDigits(date.getFullYear()) + '/';
+    result += this.formatToDoubleDigits(date.getMonth() + 1) + '/';
+    result += this.formatToDoubleDigits(date.getDate()) + ' ';
+
+    result += this.formatToDoubleDigits(date.getHours()) + ':';
+    result += this.formatToDoubleDigits(date.getMinutes()) + ':';
+    result += this.formatToDoubleDigits(date.getSeconds());
+
+    return result;
+  }
+
+  /**
+   * Formats passed number to double digits format (e.g. - 3 -> '03')
+   * @param number Number which is formatted
+   */
+  private formatToDoubleDigits(number: number): string {
+    if (number < 10) {
+      return '0' + number;
+    } else {
+      return '' + number;
+    }
+  }
+}
diff --git a/webapp/src/app/shared/datetime/datetime.component.sass b/webapp/src/app/shared/datetime/datetime.component.sass
new file mode 100644
index 0000000..31f5a82
--- /dev/null
+++ b/webapp/src/app/shared/datetime/datetime.component.sass
@@ -0,0 +1,26 @@
+
+
+.datetime-picker-container
+  display: inline-block
+
+.date-input
+  width: 100px
+  display: inline-block
+
+.time-input-container
+  display: inline-block
+  padding: 2px
+  margin-left: 3px
+  border-bottom: 1px solid grey
+
+  .time-input
+    background-color: transparent
+    border: 0
+    outline: none
+    width: 85px
+
+  .material-icons
+    font-size: 12px
+    font-weight: bold
+    color: grey
+
diff --git a/webapp/src/app/shared/datetime/datetime.component.ts b/webapp/src/app/shared/datetime/datetime.component.ts
new file mode 100644
index 0000000..b7c440b
--- /dev/null
+++ b/webapp/src/app/shared/datetime/datetime.component.ts
@@ -0,0 +1,33 @@
+import {Component, EventEmitter, Input, OnInit, Output} from '@angular/core';
+
+const DEFAULT_MINUTE_STEP = 15;
+
+@Component({
+  selector: 'app-datetime',
+  templateUrl: './datetime.component.html',
+  styleUrls: ['./datetime.component.sass']
+})
+export class DatetimeComponent implements OnInit {
+
+  @Input() date: Date;
+  @Output() dateChange = new EventEmitter<Date>();
+
+  @Input() time: string; // HH:mm format
+  @Output() timeChange = new EventEmitter<string>();
+
+  @Input() minuteStep = DEFAULT_MINUTE_STEP;
+
+  constructor() { }
+
+  ngOnInit() {
+  }
+
+  private dateChanged(): void {
+    this.dateChange.emit(this.date);
+  }
+
+  private timeChanged(newTime: string): void {
+    this.time = newTime;
+    this.timeChange.emit(this.time);
+  }
+}
diff --git a/webapp/src/app/shared/shared.module.ts b/webapp/src/app/shared/shared.module.ts
new file mode 100644
index 0000000..a57c820
--- /dev/null
+++ b/webapp/src/app/shared/shared.module.ts
@@ -0,0 +1,23 @@
+import { NgModule } from '@angular/core';
+import { CommonModule } from '@angular/common';
+import { DatetimeComponent } from './datetime/datetime.component';
+import {MatDatepickerModule, MatInputModule} from '@angular/material';
+import {NgbTimepickerModule} from '@ng-bootstrap/ng-bootstrap';
+import {FormsModule} from '@angular/forms';
+import {NgxMaterialTimepickerModule} from 'ngx-material-timepicker';
+
+@NgModule({
+  declarations: [DatetimeComponent],
+  exports: [
+    DatetimeComponent
+  ],
+  imports: [
+    CommonModule,
+    MatInputModule,
+    MatDatepickerModule,
+    NgbTimepickerModule,
+    FormsModule,
+    NgxMaterialTimepickerModule
+  ]
+})
+export class SharedModule { }
